#include "stdafx.h"
#include <cassert>
#include <fstream>
#include <iostream>
#include <iostream>
#include <boost/smart_ptr.hpp>
#include <boost/algorithm/string.hpp>
#include "tinyxml2.h"
#include "M_ActivityTaskCFG.h"
#include "FileEncrypt.h"
std::auto_ptr<M_ActivityTaskCFG> M_ActivityTaskCFG::msSingleton(nullptr);

int M_ActivityTaskCFG::GetCount()
{
	return (int)mMapData.size();
}

const M_ActivityTaskCFGData* M_ActivityTaskCFG::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

boost::unordered_map<int, M_ActivityTaskCFGData>& M_ActivityTaskCFG::GetMapData()
{
	return mMapData;
}

void M_ActivityTaskCFG::Reload()
{
	mMapData.clear();
	Load();
}

void M_ActivityTaskCFG::Load(const std::string& path)
{
	std::ifstream readStream(path, std::ios::binary);
	if (!readStream.is_open())
	{
		assert(false);
		return;
	}
	readStream.seekg(0, std::ios::end);
	int fileSize = readStream.tellg();
	boost::shared_array<char> buffer(new char[fileSize+1]);
	buffer.get()[fileSize] = '\0';
	readStream.seekg(0, std::ios::beg);
	readStream.read(buffer.get(), fileSize);
	readStream.close();
	FileEncrypt::decryptBuffer( buffer, fileSize );
	tinyxml2::XMLDocument xmlDoc;
	auto result = xmlDoc.Parse(buffer.get(), fileSize);
	if (result != tinyxml2::XML_SUCCESS)
	{
		assert(false);
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		assert(false);
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		M_ActivityTaskCFGData data;
		data.mID = element->IntAttribute("ID");
		data.mDesc1 = element->Attribute("Desc1");
		data.mDesc2 = element->Attribute("Desc2");
		data.mCompleteType = element->IntAttribute("CompleteType");
		{
			const char* CompleteCount = element->Attribute("CompleteCount");
			std::vector<std::string> vecCompleteCount;
			boost::split(vecCompleteCount, CompleteCount, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecCompleteCount.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecCompleteCount[i].c_str(), &temp))
				{
					data.mCompleteCount.push_back(temp);
				}
			}
		}
		{
			const char* AwardItem = element->Attribute("AwardItem");
			std::vector<std::string> vecAwardItem;
			boost::split(vecAwardItem, AwardItem, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecAwardItem.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecAwardItem[i].c_str(), &temp))
				{
					data.mAwardItem.push_back(temp);
				}
			}
		}
		data.mCompleteParam = element->IntAttribute("CompleteParam");
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		assert(mMapData.find(data.mID) == mMapData.end());
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
}

void M_ActivityTaskCFG::Load()
{
	Load("../Config/M_ActivityTaskCFG.xml");
}

M_ActivityTaskCFG* M_ActivityTaskCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new M_ActivityTaskCFG());
	}
	return msSingleton.get();
}
